# coding: utf-8

"""
    Identity Security Cloud Beta API

    Use these APIs to interact with the Identity Security Cloud platform to achieve repeatable, automated processes with greater scalability. These APIs are in beta and are subject to change. We encourage you to join the SailPoint Developer Community forum at https://developer.sailpoint.com/discuss to connect with other developers using our APIs.

    The version of the OpenAPI document: 3.1.0-beta
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from sailpoint.beta.models.admin_review_reassign_reassign_to import AdminReviewReassignReassignTo
from typing import Optional, Set
from typing_extensions import Self

class AdminReviewReassign(BaseModel):
    """
    AdminReviewReassign
    """ # noqa: E501
    certification_ids: Optional[Annotated[List[StrictStr], Field(min_length=1, max_length=250)]] = Field(default=None, description="List of certification IDs to reassign", alias="certificationIds")
    reassign_to: Optional[AdminReviewReassignReassignTo] = Field(default=None, alias="reassignTo")
    reason: Optional[StrictStr] = Field(default=None, description="Comment to explain why the certification was reassigned")
    __properties: ClassVar[List[str]] = ["certificationIds", "reassignTo", "reason"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return self.model_dump_json(by_alias=True, exclude_unset=True)


    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AdminReviewReassign from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of reassign_to
        if self.reassign_to:
            _dict['reassignTo'] = self.reassign_to.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AdminReviewReassign from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "certificationIds": obj.get("certificationIds"),
            "reassignTo": AdminReviewReassignReassignTo.from_dict(obj["reassignTo"]) if obj.get("reassignTo") is not None else None,
            "reason": obj.get("reason")
        })
        return _obj


