# coding: utf-8

"""
    Identity Security Cloud Beta API

    Use these APIs to interact with the Identity Security Cloud platform to achieve repeatable, automated processes with greater scalability. These APIs are in beta and are subject to change. We encourage you to join the SailPoint Developer Community forum at https://developer.sailpoint.com/discuss to connect with other developers using our APIs.

    The version of the OpenAPI document: 3.1.0-beta
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class CorrelationConfigAttributeAssignmentsInner(BaseModel):
    """
    The attribute assignment of the correlation configuration.
    """ # noqa: E501
    var_property: Optional[StrictStr] = Field(default=None, description="The property of the attribute assignment.", alias="property")
    value: Optional[StrictStr] = Field(default=None, description="The value of the attribute assignment.")
    operation: Optional[StrictStr] = Field(default=None, description="The operation of the attribute assignment.")
    complex: Optional[StrictBool] = Field(default=False, description="Whether or not the it's a complex attribute assignment.")
    ignore_case: Optional[StrictBool] = Field(default=False, description="Whether or not the attribute assignment should ignore case.", alias="ignoreCase")
    match_mode: Optional[StrictStr] = Field(default=None, description="The match mode of the attribute assignment.", alias="matchMode")
    filter_string: Optional[StrictStr] = Field(default=None, description="The filter string of the attribute assignment.", alias="filterString")
    __properties: ClassVar[List[str]] = ["property", "value", "operation", "complex", "ignoreCase", "matchMode", "filterString"]

    @field_validator('operation')
    def operation_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['EQ']):
            raise ValueError("must be one of enum values ('EQ')")
        return value

    @field_validator('match_mode')
    def match_mode_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['ANYWHERE', 'START', 'END']):
            raise ValueError("must be one of enum values ('ANYWHERE', 'START', 'END')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return self.model_dump_json(by_alias=True, exclude_unset=True)


    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CorrelationConfigAttributeAssignmentsInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CorrelationConfigAttributeAssignmentsInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "property": obj.get("property"),
            "value": obj.get("value"),
            "operation": obj.get("operation"),
            "complex": obj.get("complex") if obj.get("complex") is not None else False,
            "ignoreCase": obj.get("ignoreCase") if obj.get("ignoreCase") is not None else False,
            "matchMode": obj.get("matchMode"),
            "filterString": obj.get("filterString")
        })
        return _obj


