# coding: utf-8

"""
    Identity Security Cloud Beta API

    Use these APIs to interact with the Identity Security Cloud platform to achieve repeatable, automated processes with greater scalability. These APIs are in beta and are subject to change. We encourage you to join the SailPoint Developer Community forum at https://developer.sailpoint.com/discuss to connect with other developers using our APIs.

    The version of the OpenAPI document: 3.1.0-beta
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from sailpoint.beta.models.lookup_step import LookupStep
from typing import Optional, Set
from typing_extensions import Self

class EvaluateResponse(BaseModel):
    """
    The response body for Evaluate Reassignment Configuration
    """ # noqa: E501
    reassign_to_id: Optional[StrictStr] = Field(default=None, description="The Identity ID which should be the recipient of any work items sent to a specific identity & work type", alias="reassignToId")
    lookup_trail: Optional[List[LookupStep]] = Field(default=None, description="List of Reassignments found by looking up the next `TargetIdentity` in a ReassignmentConfiguration", alias="lookupTrail")
    __properties: ClassVar[List[str]] = ["reassignToId", "lookupTrail"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return self.model_dump_json(by_alias=True, exclude_unset=True)


    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of EvaluateResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in lookup_trail (list)
        _items = []
        if self.lookup_trail:
            for _item_lookup_trail in self.lookup_trail:
                if _item_lookup_trail:
                    _items.append(_item_lookup_trail.to_dict())
            _dict['lookupTrail'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of EvaluateResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "reassignToId": obj.get("reassignToId"),
            "lookupTrail": [LookupStep.from_dict(_item) for _item in obj["lookupTrail"]] if obj.get("lookupTrail") is not None else None
        })
        return _obj


