# coding: utf-8

"""
    Identity Security Cloud Beta API

    Use these APIs to interact with the Identity Security Cloud platform to achieve repeatable, automated processes with greater scalability. These APIs are in beta and are subject to change. We encourage you to join the SailPoint Developer Community forum at https://developer.sailpoint.com/discuss to connect with other developers using our APIs.

    The version of the OpenAPI document: 3.1.0-beta
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class HttpAuthenticationType(str, Enum):
    """
    Defines the HTTP Authentication type. Additional values may be added in the future.  If *NO_AUTH* is selected, no extra information will be in HttpConfig.  If *BASIC_AUTH* is selected, HttpConfig will include BasicAuthConfig with Username and Password as strings.  If *BEARER_TOKEN* is selected, HttpConfig will include BearerTokenAuthConfig with Token as string.
    """

    """
    allowed enum values
    """
    NO_AUTH = 'NO_AUTH'
    BASIC_AUTH = 'BASIC_AUTH'
    BEARER_TOKEN = 'BEARER_TOKEN'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of HttpAuthenticationType from a JSON string"""
        return cls(json.loads(json_str))


