# coding: utf-8

"""
    Identity Security Cloud Beta API

    Use these APIs to interact with the Identity Security Cloud platform to achieve repeatable, automated processes with greater scalability. These APIs are in beta and are subject to change. We encourage you to join the SailPoint Developer Community forum at https://developer.sailpoint.com/discuss to connect with other developers using our APIs.

    The version of the OpenAPI document: 3.1.0-beta
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from sailpoint.beta.models.account_action import AccountAction
from sailpoint.beta.models.email_notification_option import EmailNotificationOption
from typing import Optional, Set
from typing_extensions import Self

class LifecycleState(BaseModel):
    """
    LifecycleState
    """ # noqa: E501
    id: Optional[StrictStr] = Field(default=None, description="Lifecycle state ID.")
    name: Optional[StrictStr] = Field(default=None, description="Lifecycle state name.")
    technical_name: Optional[StrictStr] = Field(default=None, description="Lifecycle state technical name. This is for internal use.", alias="technicalName")
    description: Optional[StrictStr] = Field(default=None, description="Lifecycle state description.")
    created: Optional[datetime] = Field(default=None, description="Lifecycle state created date.")
    modified: Optional[datetime] = Field(default=None, description="Lifecycle state modified date.")
    enabled: Optional[StrictBool] = Field(default=False, description="Indicates whether the lifecycle state is enabled or disabled.")
    identity_count: Optional[StrictInt] = Field(default=None, description="Number of identities that have the lifecycle state.", alias="identityCount")
    email_notification_option: Optional[EmailNotificationOption] = Field(default=None, alias="emailNotificationOption")
    account_actions: Optional[List[AccountAction]] = Field(default=None, alias="accountActions")
    access_profile_ids: Optional[List[StrictStr]] = Field(default=None, description="List of access-profile IDs that are associated with the lifecycle state.", alias="accessProfileIds")
    __properties: ClassVar[List[str]] = ["id", "name", "technicalName", "description", "created", "modified", "enabled", "identityCount", "emailNotificationOption", "accountActions", "accessProfileIds"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return self.model_dump_json(by_alias=True, exclude_unset=True)


    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of LifecycleState from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "id",
            "name",
            "technical_name",
            "created",
            "modified",
            "identity_count",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of email_notification_option
        if self.email_notification_option:
            _dict['emailNotificationOption'] = self.email_notification_option.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in account_actions (list)
        _items = []
        if self.account_actions:
            for _item_account_actions in self.account_actions:
                if _item_account_actions:
                    _items.append(_item_account_actions.to_dict())
            _dict['accountActions'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of LifecycleState from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "name": obj.get("name"),
            "technicalName": obj.get("technicalName"),
            "description": obj.get("description"),
            "created": obj.get("created"),
            "modified": obj.get("modified"),
            "enabled": obj.get("enabled") if obj.get("enabled") is not None else False,
            "identityCount": obj.get("identityCount"),
            "emailNotificationOption": EmailNotificationOption.from_dict(obj["emailNotificationOption"]) if obj.get("emailNotificationOption") is not None else None,
            "accountActions": [AccountAction.from_dict(_item) for _item in obj["accountActions"]] if obj.get("accountActions") is not None else None,
            "accessProfileIds": obj.get("accessProfileIds")
        })
        return _obj


