# coding: utf-8

"""
    Identity Security Cloud Beta API

    Use these APIs to interact with the Identity Security Cloud platform to achieve repeatable, automated processes with greater scalability. These APIs are in beta and are subject to change. We encourage you to join the SailPoint Developer Community forum at https://developer.sailpoint.com/discuss to connect with other developers using our APIs.

    The version of the OpenAPI document: 3.1.0-beta
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from sailpoint.beta.models.role_insights_insight import RoleInsightsInsight
from typing import Optional, Set
from typing_extensions import Self

class RoleInsightsEntitlementChanges(BaseModel):
    """
    RoleInsightsEntitlementChanges
    """ # noqa: E501
    name: Optional[StrictStr] = Field(default=None, description="Name of the entitlement")
    id: Optional[StrictStr] = Field(default=None, description="Id of the entitlement")
    description: Optional[StrictStr] = Field(default=None, description="Description for the entitlement")
    attribute: Optional[StrictStr] = Field(default=None, description="Attribute for the entitlement")
    value: Optional[StrictStr] = Field(default=None, description="Attribute value for the entitlement")
    source: Optional[StrictStr] = Field(default=None, description="Source or the application for the entitlement")
    insight: Optional[RoleInsightsInsight] = None
    __properties: ClassVar[List[str]] = ["name", "id", "description", "attribute", "value", "source", "insight"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return self.model_dump_json(by_alias=True, exclude_unset=True)


    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RoleInsightsEntitlementChanges from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of insight
        if self.insight:
            _dict['insight'] = self.insight.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RoleInsightsEntitlementChanges from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "id": obj.get("id"),
            "description": obj.get("description"),
            "attribute": obj.get("attribute"),
            "value": obj.get("value"),
            "source": obj.get("source"),
            "insight": RoleInsightsInsight.from_dict(obj["insight"]) if obj.get("insight") is not None else None
        })
        return _obj


