# coding: utf-8

"""
    Identity Security Cloud Beta API

    Use these APIs to interact with the Identity Security Cloud platform to achieve repeatable, automated processes with greater scalability. These APIs are in beta and are subject to change. We encourage you to join the SailPoint Developer Community forum at https://developer.sailpoint.com/discuss to connect with other developers using our APIs.

    The version of the OpenAPI document: 3.1.0-beta
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class RoleInsightsInsight(BaseModel):
    """
    RoleInsightsInsight
    """ # noqa: E501
    type: Optional[StrictStr] = Field(default=None, description="The number of identities in this role with the entitlement.")
    identities_with_access: Optional[StrictInt] = Field(default=None, description="The number of identities in this role with the entitlement.", alias="identitiesWithAccess")
    identities_impacted: Optional[StrictInt] = Field(default=None, description="The number of identities in this role that do not have the specified entitlement.", alias="identitiesImpacted")
    total_number_of_identities: Optional[StrictInt] = Field(default=None, description="The total number of identities.", alias="totalNumberOfIdentities")
    impacted_identity_names: Optional[StrictStr] = Field(default=None, alias="impactedIdentityNames")
    __properties: ClassVar[List[str]] = ["type", "identitiesWithAccess", "identitiesImpacted", "totalNumberOfIdentities", "impactedIdentityNames"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return self.model_dump_json(by_alias=True, exclude_unset=True)


    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RoleInsightsInsight from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if impacted_identity_names (nullable) is None
        # and model_fields_set contains the field
        if self.impacted_identity_names is None and "impacted_identity_names" in self.model_fields_set:
            _dict['impactedIdentityNames'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RoleInsightsInsight from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "type": obj.get("type"),
            "identitiesWithAccess": obj.get("identitiesWithAccess"),
            "identitiesImpacted": obj.get("identitiesImpacted"),
            "totalNumberOfIdentities": obj.get("totalNumberOfIdentities"),
            "impactedIdentityNames": obj.get("impactedIdentityNames")
        })
        return _obj


