# coding: utf-8

"""
    Identity Security Cloud V2024 API

    Use these APIs to interact with the Identity Security Cloud platform to achieve repeatable, automated processes with greater scalability. We encourage you to join the SailPoint Developer Community forum at https://developer.sailpoint.com/discuss to connect with other developers using our APIs.

    The version of the OpenAPI document: v2024
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class AccessItemRoleResponse(BaseModel):
    """
    AccessItemRoleResponse
    """ # noqa: E501
    access_type: Optional[StrictStr] = Field(default=None, description="the access item type. role in this case", alias="accessType")
    id: Optional[StrictStr] = Field(default=None, description="the access item id")
    display_name: Optional[StrictStr] = Field(default=None, description="the role display name", alias="displayName")
    description: Optional[StrictStr] = Field(default=None, description="the description for the role")
    source_name: Optional[StrictStr] = Field(default=None, description="the associated source name if it exists", alias="sourceName")
    remove_date: Optional[StrictStr] = Field(default=None, description="the date the role is no longer assigned to the specified identity", alias="removeDate")
    revocable: StrictBool = Field(description="indicates whether the role is revocable")
    __properties: ClassVar[List[str]] = ["accessType", "id", "displayName", "description", "sourceName", "removeDate", "revocable"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return self.model_dump_json(by_alias=True, exclude_unset=True)


    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AccessItemRoleResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AccessItemRoleResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "accessType": obj.get("accessType"),
            "id": obj.get("id"),
            "displayName": obj.get("displayName"),
            "description": obj.get("description"),
            "sourceName": obj.get("sourceName"),
            "removeDate": obj.get("removeDate"),
            "revocable": obj.get("revocable")
        })
        return _obj


