# coding: utf-8

"""
    Identity Security Cloud V2024 API

    Use these APIs to interact with the Identity Security Cloud platform to achieve repeatable, automated processes with greater scalability. We encourage you to join the SailPoint Developer Community forum at https://developer.sailpoint.com/discuss to connect with other developers using our APIs.

    The version of the OpenAPI document: v2024
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from sailpoint.v2024.models.approval_info_response import ApprovalInfoResponse
from typing import Optional, Set
from typing_extensions import Self

class AccessRequestItemResponse(BaseModel):
    """
    AccessRequestItemResponse
    """ # noqa: E501
    operation: Optional[StrictStr] = Field(default=None, description="the access request item operation")
    access_item_type: Optional[StrictStr] = Field(default=None, description="the access item type", alias="accessItemType")
    name: Optional[StrictStr] = Field(default=None, description="the name of access request item")
    decision: Optional[StrictStr] = Field(default=None, description="the final decision for the access request")
    description: Optional[StrictStr] = Field(default=None, description="the description of access request item")
    source_id: Optional[StrictStr] = Field(default=None, description="the source id", alias="sourceId")
    source_name: Optional[StrictStr] = Field(default=None, description="the source Name", alias="sourceName")
    approval_infos: Optional[List[ApprovalInfoResponse]] = Field(default=None, alias="approvalInfos")
    __properties: ClassVar[List[str]] = ["operation", "accessItemType", "name", "decision", "description", "sourceId", "sourceName", "approvalInfos"]

    @field_validator('decision')
    def decision_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['APPROVED', 'REJECTED']):
            raise ValueError("must be one of enum values ('APPROVED', 'REJECTED')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return self.model_dump_json(by_alias=True, exclude_unset=True)


    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AccessRequestItemResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in approval_infos (list)
        _items = []
        if self.approval_infos:
            for _item_approval_infos in self.approval_infos:
                if _item_approval_infos:
                    _items.append(_item_approval_infos.to_dict())
            _dict['approvalInfos'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AccessRequestItemResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "operation": obj.get("operation"),
            "accessItemType": obj.get("accessItemType"),
            "name": obj.get("name"),
            "decision": obj.get("decision"),
            "description": obj.get("description"),
            "sourceId": obj.get("sourceId"),
            "sourceName": obj.get("sourceName"),
            "approvalInfos": [ApprovalInfoResponse.from_dict(_item) for _item in obj["approvalInfos"]] if obj.get("approvalInfos") is not None else None
        })
        return _obj


