# coding: utf-8

"""
    Identity Security Cloud V2024 API

    Use these APIs to interact with the Identity Security Cloud platform to achieve repeatable, automated processes with greater scalability. We encourage you to join the SailPoint Developer Community forum at https://developer.sailpoint.com/discuss to connect with other developers using our APIs.

    The version of the OpenAPI document: v2024
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from sailpoint.v2024.models.access_recommendation_message import AccessRecommendationMessage
from sailpoint.v2024.models.access_request_recommendation_item_detail_access import AccessRequestRecommendationItemDetailAccess
from sailpoint.v2024.models.translation_message import TranslationMessage
from typing import Optional, Set
from typing_extensions import Self

class AccessRequestRecommendationItemDetail(BaseModel):
    """
    AccessRequestRecommendationItemDetail
    """ # noqa: E501
    identity_id: Optional[StrictStr] = Field(default=None, description="Identity ID for the recommendation", alias="identityId")
    access: Optional[AccessRequestRecommendationItemDetailAccess] = None
    ignored: Optional[StrictBool] = Field(default=None, description="Whether or not the identity has already chosen to ignore this recommendation.")
    requested: Optional[StrictBool] = Field(default=None, description="Whether or not the identity has already chosen to request this recommendation.")
    viewed: Optional[StrictBool] = Field(default=None, description="Whether or not the identity reportedly viewed this recommendation.")
    messages: Optional[List[AccessRecommendationMessage]] = None
    translation_messages: Optional[List[TranslationMessage]] = Field(default=None, description="The list of translation messages", alias="translationMessages")
    __properties: ClassVar[List[str]] = ["identityId", "access", "ignored", "requested", "viewed", "messages", "translationMessages"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return self.model_dump_json(by_alias=True, exclude_unset=True)


    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AccessRequestRecommendationItemDetail from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of access
        if self.access:
            _dict['access'] = self.access.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in messages (list)
        _items = []
        if self.messages:
            for _item_messages in self.messages:
                if _item_messages:
                    _items.append(_item_messages.to_dict())
            _dict['messages'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in translation_messages (list)
        _items = []
        if self.translation_messages:
            for _item_translation_messages in self.translation_messages:
                if _item_translation_messages:
                    _items.append(_item_translation_messages.to_dict())
            _dict['translationMessages'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AccessRequestRecommendationItemDetail from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "identityId": obj.get("identityId"),
            "access": AccessRequestRecommendationItemDetailAccess.from_dict(obj["access"]) if obj.get("access") is not None else None,
            "ignored": obj.get("ignored"),
            "requested": obj.get("requested"),
            "viewed": obj.get("viewed"),
            "messages": [AccessRecommendationMessage.from_dict(_item) for _item in obj["messages"]] if obj.get("messages") is not None else None,
            "translationMessages": [TranslationMessage.from_dict(_item) for _item in obj["translationMessages"]] if obj.get("translationMessages") is not None else None
        })
        return _obj


