# coding: utf-8

"""
    Identity Security Cloud V2024 API

    Use these APIs to interact with the Identity Security Cloud platform to achieve repeatable, automated processes with greater scalability. We encourage you to join the SailPoint Developer Community forum at https://developer.sailpoint.com/discuss to connect with other developers using our APIs.

    The version of the OpenAPI document: v2024
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from sailpoint.v2024.models.account_attributes_changed_changes_inner_new_value import AccountAttributesChangedChangesInnerNewValue
from sailpoint.v2024.models.account_attributes_changed_changes_inner_old_value import AccountAttributesChangedChangesInnerOldValue
from typing import Optional, Set
from typing_extensions import Self

class AccountAttributesChangedChangesInner(BaseModel):
    """
    AccountAttributesChangedChangesInner
    """ # noqa: E501
    attribute: StrictStr = Field(description="The name of the attribute.")
    old_value: Optional[AccountAttributesChangedChangesInnerOldValue] = Field(alias="oldValue")
    new_value: Optional[AccountAttributesChangedChangesInnerNewValue] = Field(alias="newValue")
    __properties: ClassVar[List[str]] = ["attribute", "oldValue", "newValue"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return self.model_dump_json(by_alias=True, exclude_unset=True)


    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AccountAttributesChangedChangesInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of old_value
        if self.old_value:
            _dict['oldValue'] = self.old_value.to_dict()
        # override the default output from pydantic by calling `to_dict()` of new_value
        if self.new_value:
            _dict['newValue'] = self.new_value.to_dict()
        # set to None if old_value (nullable) is None
        # and model_fields_set contains the field
        if self.old_value is None and "old_value" in self.model_fields_set:
            _dict['oldValue'] = None

        # set to None if new_value (nullable) is None
        # and model_fields_set contains the field
        if self.new_value is None and "new_value" in self.model_fields_set:
            _dict['newValue'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AccountAttributesChangedChangesInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "attribute": obj.get("attribute"),
            "oldValue": AccountAttributesChangedChangesInnerOldValue.from_dict(obj["oldValue"]) if obj.get("oldValue") is not None else None,
            "newValue": AccountAttributesChangedChangesInnerNewValue.from_dict(obj["newValue"]) if obj.get("newValue") is not None else None
        })
        return _obj


