# coding: utf-8

"""
    Identity Security Cloud V2024 API

    Use these APIs to interact with the Identity Security Cloud platform to achieve repeatable, automated processes with greater scalability. We encourage you to join the SailPoint Developer Community forum at https://developer.sailpoint.com/discuss to connect with other developers using our APIs.

    The version of the OpenAPI document: v2024
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from sailpoint.v2024.models.account_request_result import AccountRequestResult
from sailpoint.v2024.models.account_source import AccountSource
from sailpoint.v2024.models.attribute_request import AttributeRequest
from typing import Optional, Set
from typing_extensions import Self

class AccountRequest(BaseModel):
    """
    AccountRequest
    """ # noqa: E501
    account_id: Optional[StrictStr] = Field(default=None, description="Unique ID of the account", alias="accountId")
    attribute_requests: Optional[List[AttributeRequest]] = Field(default=None, alias="attributeRequests")
    op: Optional[StrictStr] = Field(default=None, description="The operation that was performed")
    provisioning_target: Optional[AccountSource] = Field(default=None, alias="provisioningTarget")
    result: Optional[AccountRequestResult] = None
    source: Optional[AccountSource] = None
    __properties: ClassVar[List[str]] = ["accountId", "attributeRequests", "op", "provisioningTarget", "result", "source"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return self.model_dump_json(by_alias=True, exclude_unset=True)


    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AccountRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in attribute_requests (list)
        _items = []
        if self.attribute_requests:
            for _item_attribute_requests in self.attribute_requests:
                if _item_attribute_requests:
                    _items.append(_item_attribute_requests.to_dict())
            _dict['attributeRequests'] = _items
        # override the default output from pydantic by calling `to_dict()` of provisioning_target
        if self.provisioning_target:
            _dict['provisioningTarget'] = self.provisioning_target.to_dict()
        # override the default output from pydantic by calling `to_dict()` of result
        if self.result:
            _dict['result'] = self.result.to_dict()
        # override the default output from pydantic by calling `to_dict()` of source
        if self.source:
            _dict['source'] = self.source.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AccountRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "accountId": obj.get("accountId"),
            "attributeRequests": [AttributeRequest.from_dict(_item) for _item in obj["attributeRequests"]] if obj.get("attributeRequests") is not None else None,
            "op": obj.get("op"),
            "provisioningTarget": AccountSource.from_dict(obj["provisioningTarget"]) if obj.get("provisioningTarget") is not None else None,
            "result": AccountRequestResult.from_dict(obj["result"]) if obj.get("result") is not None else None,
            "source": AccountSource.from_dict(obj["source"]) if obj.get("source") is not None else None
        })
        return _obj


