# coding: utf-8

"""
    Identity Security Cloud V2024 API

    Use these APIs to interact with the Identity Security Cloud platform to achieve repeatable, automated processes with greater scalability. We encourage you to join the SailPoint Developer Community forum at https://developer.sailpoint.com/discuss to connect with other developers using our APIs.

    The version of the OpenAPI document: v2024
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from sailpoint.v2024.models.account_status_changed_account import AccountStatusChangedAccount
from sailpoint.v2024.models.account_status_changed_status_change import AccountStatusChangedStatusChange
from typing import Optional, Set
from typing_extensions import Self

class AccountStatusChanged(BaseModel):
    """
    AccountStatusChanged
    """ # noqa: E501
    event_type: Optional[StrictStr] = Field(default=None, description="the event type", alias="eventType")
    identity_id: Optional[StrictStr] = Field(default=None, description="the identity id", alias="identityId")
    dt: Optional[StrictStr] = Field(default=None, description="the date of event")
    account: Optional[AccountStatusChangedAccount] = None
    status_change: Optional[AccountStatusChangedStatusChange] = Field(default=None, alias="statusChange")
    __properties: ClassVar[List[str]] = ["eventType", "identityId", "dt", "account", "statusChange"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return self.model_dump_json(by_alias=True, exclude_unset=True)


    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AccountStatusChanged from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of account
        if self.account:
            _dict['account'] = self.account.to_dict()
        # override the default output from pydantic by calling `to_dict()` of status_change
        if self.status_change:
            _dict['statusChange'] = self.status_change.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AccountStatusChanged from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "eventType": obj.get("eventType"),
            "identityId": obj.get("identityId"),
            "dt": obj.get("dt"),
            "account": AccountStatusChangedAccount.from_dict(obj["account"]) if obj.get("account") is not None else None,
            "statusChange": AccountStatusChangedStatusChange.from_dict(obj["statusChange"]) if obj.get("statusChange") is not None else None
        })
        return _obj


