# coding: utf-8

"""
    Identity Security Cloud V2024 API

    Use these APIs to interact with the Identity Security Cloud platform to achieve repeatable, automated processes with greater scalability. We encourage you to join the SailPoint Developer Community forum at https://developer.sailpoint.com/discuss to connect with other developers using our APIs.

    The version of the OpenAPI document: v2024
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List
from typing import Optional, Set
from typing_extensions import Self

class ApprovalComment(BaseModel):
    """
    ApprovalComment
    """ # noqa: E501
    comment: StrictStr = Field(description="Comment provided either by the approval requester or the approver.")
    timestamp: datetime = Field(description="The time when this comment was provided.")
    user: StrictStr = Field(description="Name of the user that provided this comment.")
    id: StrictStr = Field(description="Id of the user that provided this comment.")
    changed_to_status: StrictStr = Field(description="Status transition of the draft.", alias="changedToStatus")
    __properties: ClassVar[List[str]] = ["comment", "timestamp", "user", "id", "changedToStatus"]

    @field_validator('changed_to_status')
    def changed_to_status_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['PENDING_APPROVAL', 'APPROVED', 'REJECTED']):
            raise ValueError("must be one of enum values ('PENDING_APPROVAL', 'APPROVED', 'REJECTED')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return self.model_dump_json(by_alias=True, exclude_unset=True)


    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ApprovalComment from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ApprovalComment from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "comment": obj.get("comment"),
            "timestamp": obj.get("timestamp"),
            "user": obj.get("user"),
            "id": obj.get("id"),
            "changedToStatus": obj.get("changedToStatus")
        })
        return _obj


