# coding: utf-8

"""
    Identity Security Cloud V2024 API

    Use these APIs to interact with the Identity Security Cloud platform to achieve repeatable, automated processes with greater scalability. We encourage you to join the SailPoint Developer Community forum at https://developer.sailpoint.com/discuss to connect with other developers using our APIs.

    The version of the OpenAPI document: v2024
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class AuthProfile(BaseModel):
    """
    AuthProfile
    """ # noqa: E501
    name: Optional[StrictStr] = Field(default=None, description="Authentication Profile name.")
    off_network: Optional[StrictBool] = Field(default=False, description="Use it to block access from off network.", alias="offNetwork")
    untrusted_geography: Optional[StrictBool] = Field(default=False, description="Use it to block access from untrusted geoographies.", alias="untrustedGeography")
    application_id: Optional[StrictStr] = Field(default=None, description="Application ID.", alias="applicationId")
    application_name: Optional[StrictStr] = Field(default=None, description="Application name.", alias="applicationName")
    type: Optional[StrictStr] = Field(default=None, description="Type of the Authentication Profile.")
    strong_auth_login: Optional[StrictBool] = Field(default=False, description="Use it to enable strong authentication.", alias="strongAuthLogin")
    __properties: ClassVar[List[str]] = ["name", "offNetwork", "untrustedGeography", "applicationId", "applicationName", "type", "strongAuthLogin"]

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['BLOCK', 'MFA', 'NON_PTA', 'PTA']):
            raise ValueError("must be one of enum values ('BLOCK', 'MFA', 'NON_PTA', 'PTA')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return self.model_dump_json(by_alias=True, exclude_unset=True)


    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AuthProfile from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AuthProfile from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "offNetwork": obj.get("offNetwork") if obj.get("offNetwork") is not None else False,
            "untrustedGeography": obj.get("untrustedGeography") if obj.get("untrustedGeography") is not None else False,
            "applicationId": obj.get("applicationId"),
            "applicationName": obj.get("applicationName"),
            "type": obj.get("type"),
            "strongAuthLogin": obj.get("strongAuthLogin") if obj.get("strongAuthLogin") is not None else False
        })
        return _obj


