# coding: utf-8

"""
    Identity Security Cloud V2024 API

    Use these APIs to interact with the Identity Security Cloud platform to achieve repeatable, automated processes with greater scalability. We encourage you to join the SailPoint Developer Community forum at https://developer.sailpoint.com/discuss to connect with other developers using our APIs.

    The version of the OpenAPI document: v2024
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from sailpoint.v2024.models.audit_details import AuditDetails
from sailpoint.v2024.models.config_type_enum import ConfigTypeEnum
from sailpoint.v2024.models.identity1 import Identity1
from typing import Optional, Set
from typing_extensions import Self

class ConfigurationDetailsResponse(BaseModel):
    """
    The request body of Reassignment Configuration Details for a specific identity and config type
    """ # noqa: E501
    config_type: Optional[ConfigTypeEnum] = Field(default=None, alias="configType")
    target_identity: Optional[Identity1] = Field(default=None, alias="targetIdentity")
    start_date: Optional[datetime] = Field(default=None, description="The date from which to start reassigning work items", alias="startDate")
    end_date: Optional[datetime] = Field(default=None, description="The date from which to stop reassigning work items.  If this is an empty string it indicates a permanent reassignment.", alias="endDate")
    audit_details: Optional[AuditDetails] = Field(default=None, alias="auditDetails")
    __properties: ClassVar[List[str]] = ["configType", "targetIdentity", "startDate", "endDate", "auditDetails"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return self.model_dump_json(by_alias=True, exclude_unset=True)


    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ConfigurationDetailsResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of target_identity
        if self.target_identity:
            _dict['targetIdentity'] = self.target_identity.to_dict()
        # override the default output from pydantic by calling `to_dict()` of audit_details
        if self.audit_details:
            _dict['auditDetails'] = self.audit_details.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ConfigurationDetailsResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "configType": obj.get("configType"),
            "targetIdentity": Identity1.from_dict(obj["targetIdentity"]) if obj.get("targetIdentity") is not None else None,
            "startDate": obj.get("startDate"),
            "endDate": obj.get("endDate"),
            "auditDetails": AuditDetails.from_dict(obj["auditDetails"]) if obj.get("auditDetails") is not None else None
        })
        return _obj


