# coding: utf-8

"""
    Identity Security Cloud V2024 API

    Use these APIs to interact with the Identity Security Cloud platform to achieve repeatable, automated processes with greater scalability. We encourage you to join the SailPoint Developer Community forum at https://developer.sailpoint.com/discuss to connect with other developers using our APIs.

    The version of the OpenAPI document: v2024
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from sailpoint.v2024.models.config_type_enum import ConfigTypeEnum
from typing import Optional, Set
from typing_extensions import Self

class ConfigurationItemRequest(BaseModel):
    """
    The request body for creation or update of a Reassignment Configuration for a single identity and work type
    """ # noqa: E501
    reassigned_from_id: Optional[StrictStr] = Field(default=None, description="The identity id to reassign an item from", alias="reassignedFromId")
    reassigned_to_id: Optional[StrictStr] = Field(default=None, description="The identity id to reassign an item to", alias="reassignedToId")
    config_type: Optional[ConfigTypeEnum] = Field(default=None, alias="configType")
    start_date: Optional[datetime] = Field(default=None, description="The date from which to start reassigning work items", alias="startDate")
    end_date: Optional[datetime] = Field(default=None, description="The date from which to stop reassigning work items.  If this is an null string it indicates a permanent reassignment.", alias="endDate")
    __properties: ClassVar[List[str]] = ["reassignedFromId", "reassignedToId", "configType", "startDate", "endDate"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return self.model_dump_json(by_alias=True, exclude_unset=True)


    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ConfigurationItemRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if end_date (nullable) is None
        # and model_fields_set contains the field
        if self.end_date is None and "end_date" in self.model_fields_set:
            _dict['endDate'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ConfigurationItemRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "reassignedFromId": obj.get("reassignedFromId"),
            "reassignedToId": obj.get("reassignedToId"),
            "configType": obj.get("configType"),
            "startDate": obj.get("startDate"),
            "endDate": obj.get("endDate")
        })
        return _obj


