# coding: utf-8

"""
    Identity Security Cloud V2024 API

    Use these APIs to interact with the Identity Security Cloud platform to achieve repeatable, automated processes with greater scalability. We encourage you to join the SailPoint Developer Community forum at https://developer.sailpoint.com/discuss to connect with other developers using our APIs.

    The version of the OpenAPI document: v2024
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class ConnectorDetail1(BaseModel):
    """
    ConnectorDetail1
    """ # noqa: E501
    name: Optional[StrictStr] = Field(default=None, description="The connector name")
    source_config_xml: Optional[StrictStr] = Field(default=None, description="XML representation of the source config data", alias="sourceConfigXml")
    source_config: Optional[StrictStr] = Field(default=None, description="JSON representation of the source config data", alias="sourceConfig")
    direct_connect: Optional[StrictBool] = Field(default=None, description="true if the source is a direct connect source", alias="directConnect")
    file_upload: Optional[StrictBool] = Field(default=None, description="Connector config's file upload attribute, false if not there", alias="fileUpload")
    uploaded_files: Optional[StrictStr] = Field(default=None, description="List of uploaded file strings for the connector", alias="uploadedFiles")
    connector_metadata: Optional[Dict[str, Any]] = Field(default=None, description="Object containing metadata pertinent to the UI to be used", alias="connectorMetadata")
    __properties: ClassVar[List[str]] = ["name", "sourceConfigXml", "sourceConfig", "directConnect", "fileUpload", "uploadedFiles", "connectorMetadata"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return self.model_dump_json(by_alias=True, exclude_unset=True)


    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ConnectorDetail1 from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ConnectorDetail1 from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "sourceConfigXml": obj.get("sourceConfigXml"),
            "sourceConfig": obj.get("sourceConfig"),
            "directConnect": obj.get("directConnect"),
            "fileUpload": obj.get("fileUpload"),
            "uploadedFiles": obj.get("uploadedFiles"),
            "connectorMetadata": obj.get("connectorMetadata")
        })
        return _obj


