# coding: utf-8

"""
    Identity Security Cloud V2024 API

    Use these APIs to interact with the Identity Security Cloud platform to achieve repeatable, automated processes with greater scalability. We encourage you to join the SailPoint Developer Community forum at https://developer.sailpoint.com/discuss to connect with other developers using our APIs.

    The version of the OpenAPI document: v2024
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from sailpoint.v2024.models.data_access_categories_inner import DataAccessCategoriesInner
from sailpoint.v2024.models.data_access_impact_score import DataAccessImpactScore
from sailpoint.v2024.models.data_access_policies_inner import DataAccessPoliciesInner
from typing import Optional, Set
from typing_extensions import Self

class DataAccess(BaseModel):
    """
    DAS data for the entitlement
    """ # noqa: E501
    policies: Optional[List[DataAccessPoliciesInner]] = Field(default=None, description="List of classification policies that apply to resources the entitlement \\ groups has access to")
    categories: Optional[List[DataAccessCategoriesInner]] = Field(default=None, description="List of classification categories that apply to resources the entitlement \\ groups has access to")
    impact_score: Optional[DataAccessImpactScore] = Field(default=None, alias="impactScore")
    __properties: ClassVar[List[str]] = ["policies", "categories", "impactScore"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return self.model_dump_json(by_alias=True, exclude_unset=True)


    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DataAccess from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in policies (list)
        _items = []
        if self.policies:
            for _item_policies in self.policies:
                if _item_policies:
                    _items.append(_item_policies.to_dict())
            _dict['policies'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in categories (list)
        _items = []
        if self.categories:
            for _item_categories in self.categories:
                if _item_categories:
                    _items.append(_item_categories.to_dict())
            _dict['categories'] = _items
        # override the default output from pydantic by calling `to_dict()` of impact_score
        if self.impact_score:
            _dict['impactScore'] = self.impact_score.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DataAccess from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "policies": [DataAccessPoliciesInner.from_dict(_item) for _item in obj["policies"]] if obj.get("policies") is not None else None,
            "categories": [DataAccessCategoriesInner.from_dict(_item) for _item in obj["categories"]] if obj.get("categories") is not None else None,
            "impactScore": DataAccessImpactScore.from_dict(obj["impactScore"]) if obj.get("impactScore") is not None else None
        })
        return _obj


