# coding: utf-8

"""
    Identity Security Cloud V2024 API

    Use these APIs to interact with the Identity Security Cloud platform to achieve repeatable, automated processes with greater scalability. We encourage you to join the SailPoint Developer Community forum at https://developer.sailpoint.com/discuss to connect with other developers using our APIs.

    The version of the OpenAPI document: v2024
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class DkimAttributes(BaseModel):
    """
    DKIM attributes for a domain or identity
    """ # noqa: E501
    id: Optional[StrictStr] = Field(default=None, description="UUID associated with domain to be verified")
    address: Optional[StrictStr] = Field(default=None, description="The identity or domain address")
    dkim_enabled: Optional[StrictBool] = Field(default=False, description="Whether or not DKIM has been enabled for this domain / identity", alias="dkimEnabled")
    dkim_tokens: Optional[List[StrictStr]] = Field(default=None, description="The tokens to be added to a DNS for verification", alias="dkimTokens")
    dkim_verification_status: Optional[StrictStr] = Field(default=None, description="The current status if the domain /identity has been verified. Ie Success, Failed, Pending", alias="dkimVerificationStatus")
    __properties: ClassVar[List[str]] = ["id", "address", "dkimEnabled", "dkimTokens", "dkimVerificationStatus"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return self.model_dump_json(by_alias=True, exclude_unset=True)


    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DkimAttributes from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DkimAttributes from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "address": obj.get("address"),
            "dkimEnabled": obj.get("dkimEnabled") if obj.get("dkimEnabled") is not None else False,
            "dkimTokens": obj.get("dkimTokens"),
            "dkimVerificationStatus": obj.get("dkimVerificationStatus")
        })
        return _obj


