# coding: utf-8

"""
    Identity Security Cloud V2024 API

    Use these APIs to interact with the Identity Security Cloud platform to achieve repeatable, automated processes with greater scalability. We encourage you to join the SailPoint Developer Community forum at https://developer.sailpoint.com/discuss to connect with other developers using our APIs.

    The version of the OpenAPI document: v2024
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class FullDiscoveredApplications(BaseModel):
    """
    Discovered applications with their respective associated sources
    """ # noqa: E501
    id: Optional[StrictStr] = Field(default=None, description="Unique identifier for the discovered application.")
    name: Optional[StrictStr] = Field(default=None, description="Name of the discovered application.")
    discovery_source: Optional[StrictStr] = Field(default=None, description="Source from which the application was discovered.", alias="discoverySource")
    discovered_vendor: Optional[StrictStr] = Field(default=None, description="The vendor associated with the discovered application.", alias="discoveredVendor")
    description: Optional[StrictStr] = Field(default=None, description="A brief description of the discovered application.")
    recommended_connectors: Optional[List[StrictStr]] = Field(default=None, description="List of recommended connectors for the application.", alias="recommendedConnectors")
    discovered_at: Optional[datetime] = Field(default=None, description="The timestamp when the application was last received via an entitlement aggregation invocation  or a manual csv upload, in ISO 8601 format.", alias="discoveredAt")
    created_at: Optional[datetime] = Field(default=None, description="The timestamp when the application was first discovered, in ISO 8601 format.", alias="createdAt")
    status: Optional[StrictStr] = Field(default=None, description="The status of an application within the discovery source.  By default this field is set to \"ACTIVE\" when the application is discovered.  If an application has been deleted from within the discovery source, the status will be set to \"INACTIVE\".")
    associated_sources: Optional[List[StrictStr]] = Field(default=None, description="List of associated sources related to this discovered application.", alias="associatedSources")
    __properties: ClassVar[List[str]] = ["id", "name", "discoverySource", "discoveredVendor", "description", "recommendedConnectors", "discoveredAt", "createdAt", "status", "associatedSources"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return self.model_dump_json(by_alias=True, exclude_unset=True)


    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of FullDiscoveredApplications from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of FullDiscoveredApplications from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "name": obj.get("name"),
            "discoverySource": obj.get("discoverySource"),
            "discoveredVendor": obj.get("discoveredVendor"),
            "description": obj.get("description"),
            "recommendedConnectors": obj.get("recommendedConnectors"),
            "discoveredAt": obj.get("discoveredAt"),
            "createdAt": obj.get("createdAt"),
            "status": obj.get("status"),
            "associatedSources": obj.get("associatedSources")
        })
        return _obj


