# coding: utf-8

"""
    Identity Security Cloud V2024 API

    Use these APIs to interact with the Identity Security Cloud platform to achieve repeatable, automated processes with greater scalability. We encourage you to join the SailPoint Developer Community forum at https://developer.sailpoint.com/discuss to connect with other developers using our APIs.

    The version of the OpenAPI document: v2024
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class IdentityCertDecisionSummary(BaseModel):
    """
    IdentityCertDecisionSummary
    """ # noqa: E501
    entitlement_decisions_made: Optional[StrictInt] = Field(default=None, description="Number of entitlement decisions that have been made", alias="entitlementDecisionsMade")
    access_profile_decisions_made: Optional[StrictInt] = Field(default=None, description="Number of access profile decisions that have been made", alias="accessProfileDecisionsMade")
    role_decisions_made: Optional[StrictInt] = Field(default=None, description="Number of role decisions that have been made", alias="roleDecisionsMade")
    account_decisions_made: Optional[StrictInt] = Field(default=None, description="Number of account decisions that have been made", alias="accountDecisionsMade")
    entitlement_decisions_total: Optional[StrictInt] = Field(default=None, description="The total number of entitlement decisions on the certification, both complete and incomplete", alias="entitlementDecisionsTotal")
    access_profile_decisions_total: Optional[StrictInt] = Field(default=None, description="The total number of access profile decisions on the certification, both complete and incomplete", alias="accessProfileDecisionsTotal")
    role_decisions_total: Optional[StrictInt] = Field(default=None, description="The total number of role decisions on the certification, both complete and incomplete", alias="roleDecisionsTotal")
    account_decisions_total: Optional[StrictInt] = Field(default=None, description="The total number of account decisions on the certification, both complete and incomplete", alias="accountDecisionsTotal")
    entitlements_approved: Optional[StrictInt] = Field(default=None, description="The number of entitlement decisions that have been made which were approved", alias="entitlementsApproved")
    entitlements_revoked: Optional[StrictInt] = Field(default=None, description="The number of entitlement decisions that have been made which were revoked", alias="entitlementsRevoked")
    access_profiles_approved: Optional[StrictInt] = Field(default=None, description="The number of access profile decisions that have been made which were approved", alias="accessProfilesApproved")
    access_profiles_revoked: Optional[StrictInt] = Field(default=None, description="The number of access profile decisions that have been made which were revoked", alias="accessProfilesRevoked")
    roles_approved: Optional[StrictInt] = Field(default=None, description="The number of role decisions that have been made which were approved", alias="rolesApproved")
    roles_revoked: Optional[StrictInt] = Field(default=None, description="The number of role decisions that have been made which were revoked", alias="rolesRevoked")
    accounts_approved: Optional[StrictInt] = Field(default=None, description="The number of account decisions that have been made which were approved", alias="accountsApproved")
    accounts_revoked: Optional[StrictInt] = Field(default=None, description="The number of account decisions that have been made which were revoked", alias="accountsRevoked")
    __properties: ClassVar[List[str]] = ["entitlementDecisionsMade", "accessProfileDecisionsMade", "roleDecisionsMade", "accountDecisionsMade", "entitlementDecisionsTotal", "accessProfileDecisionsTotal", "roleDecisionsTotal", "accountDecisionsTotal", "entitlementsApproved", "entitlementsRevoked", "accessProfilesApproved", "accessProfilesRevoked", "rolesApproved", "rolesRevoked", "accountsApproved", "accountsRevoked"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return self.model_dump_json(by_alias=True, exclude_unset=True)


    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of IdentityCertDecisionSummary from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of IdentityCertDecisionSummary from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "entitlementDecisionsMade": obj.get("entitlementDecisionsMade"),
            "accessProfileDecisionsMade": obj.get("accessProfileDecisionsMade"),
            "roleDecisionsMade": obj.get("roleDecisionsMade"),
            "accountDecisionsMade": obj.get("accountDecisionsMade"),
            "entitlementDecisionsTotal": obj.get("entitlementDecisionsTotal"),
            "accessProfileDecisionsTotal": obj.get("accessProfileDecisionsTotal"),
            "roleDecisionsTotal": obj.get("roleDecisionsTotal"),
            "accountDecisionsTotal": obj.get("accountDecisionsTotal"),
            "entitlementsApproved": obj.get("entitlementsApproved"),
            "entitlementsRevoked": obj.get("entitlementsRevoked"),
            "accessProfilesApproved": obj.get("accessProfilesApproved"),
            "accessProfilesRevoked": obj.get("accessProfilesRevoked"),
            "rolesApproved": obj.get("rolesApproved"),
            "rolesRevoked": obj.get("rolesRevoked"),
            "accountsApproved": obj.get("accountsApproved"),
            "accountsRevoked": obj.get("accountsRevoked")
        })
        return _obj


