# coding: utf-8

"""
    Identity Security Cloud V2024 API

    Use these APIs to interact with the Identity Security Cloud platform to achieve repeatable, automated processes with greater scalability. We encourage you to join the SailPoint Developer Community forum at https://developer.sailpoint.com/discuss to connect with other developers using our APIs.

    The version of the OpenAPI document: v2024
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from sailpoint.v2024.models.load_entitlement_task_returns_inner import LoadEntitlementTaskReturnsInner
from typing import Optional, Set
from typing_extensions import Self

class LoadEntitlementTask(BaseModel):
    """
    LoadEntitlementTask
    """ # noqa: E501
    id: Optional[StrictStr] = Field(default=None, description="System-generated unique ID of the task this taskStatus represents")
    type: Optional[StrictStr] = Field(default=None, description="Type of task this task represents")
    unique_name: Optional[StrictStr] = Field(default=None, description="The name of the task", alias="uniqueName")
    description: Optional[StrictStr] = Field(default=None, description="The description of the task")
    launcher: Optional[StrictStr] = Field(default=None, description="The user who initiated the task")
    created: Optional[datetime] = Field(default=None, description="The creation date of the task")
    returns: Optional[List[LoadEntitlementTaskReturnsInner]] = Field(default=None, description="Return values from the task")
    __properties: ClassVar[List[str]] = ["id", "type", "uniqueName", "description", "launcher", "created", "returns"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return self.model_dump_json(by_alias=True, exclude_unset=True)


    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of LoadEntitlementTask from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in returns (list)
        _items = []
        if self.returns:
            for _item_returns in self.returns:
                if _item_returns:
                    _items.append(_item_returns.to_dict())
            _dict['returns'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of LoadEntitlementTask from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "type": obj.get("type"),
            "uniqueName": obj.get("uniqueName"),
            "description": obj.get("description"),
            "launcher": obj.get("launcher"),
            "created": obj.get("created"),
            "returns": [LoadEntitlementTaskReturnsInner.from_dict(_item) for _item in obj["returns"]] if obj.get("returns") is not None else None
        })
        return _obj


