# coding: utf-8

"""
    Identity Security Cloud V2024 API

    Use these APIs to interact with the Identity Security Cloud platform to achieve repeatable, automated processes with greater scalability. We encourage you to join the SailPoint Developer Community forum at https://developer.sailpoint.com/discuss to connect with other developers using our APIs.

    The version of the OpenAPI document: v2024
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from sailpoint.v2024.models.outlier_feature_summary_outlier_feature_display_values_inner import OutlierFeatureSummaryOutlierFeatureDisplayValuesInner
from typing import Optional, Set
from typing_extensions import Self

class OutlierFeatureSummary(BaseModel):
    """
    OutlierFeatureSummary
    """ # noqa: E501
    contributing_feature_name: Optional[StrictStr] = Field(default=None, description="Contributing feature name", alias="contributingFeatureName")
    identity_outlier_display_name: Optional[StrictStr] = Field(default=None, description="Identity display name", alias="identityOutlierDisplayName")
    outlier_feature_display_values: Optional[List[OutlierFeatureSummaryOutlierFeatureDisplayValuesInner]] = Field(default=None, alias="outlierFeatureDisplayValues")
    feature_definition: Optional[StrictStr] = Field(default=None, description="Definition of the feature", alias="featureDefinition")
    feature_explanation: Optional[StrictStr] = Field(default=None, description="Detailed explanation of the feature", alias="featureExplanation")
    peer_display_name: Optional[StrictStr] = Field(default=None, description="outlier's peer identity display name", alias="peerDisplayName")
    peer_identity_id: Optional[StrictStr] = Field(default=None, description="outlier's peer identity id", alias="peerIdentityId")
    access_item_reference: Optional[Dict[str, Any]] = Field(default=None, description="Access Item reference", alias="accessItemReference")
    __properties: ClassVar[List[str]] = ["contributingFeatureName", "identityOutlierDisplayName", "outlierFeatureDisplayValues", "featureDefinition", "featureExplanation", "peerDisplayName", "peerIdentityId", "accessItemReference"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return self.model_dump_json(by_alias=True, exclude_unset=True)


    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of OutlierFeatureSummary from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in outlier_feature_display_values (list)
        _items = []
        if self.outlier_feature_display_values:
            for _item_outlier_feature_display_values in self.outlier_feature_display_values:
                if _item_outlier_feature_display_values:
                    _items.append(_item_outlier_feature_display_values.to_dict())
            _dict['outlierFeatureDisplayValues'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of OutlierFeatureSummary from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "contributingFeatureName": obj.get("contributingFeatureName"),
            "identityOutlierDisplayName": obj.get("identityOutlierDisplayName"),
            "outlierFeatureDisplayValues": [OutlierFeatureSummaryOutlierFeatureDisplayValuesInner.from_dict(_item) for _item in obj["outlierFeatureDisplayValues"]] if obj.get("outlierFeatureDisplayValues") is not None else None,
            "featureDefinition": obj.get("featureDefinition"),
            "featureExplanation": obj.get("featureExplanation"),
            "peerDisplayName": obj.get("peerDisplayName"),
            "peerIdentityId": obj.get("peerIdentityId"),
            "accessItemReference": obj.get("accessItemReference")
        })
        return _obj


