# coding: utf-8

"""
    Identity Security Cloud V2024 API

    Use these APIs to interact with the Identity Security Cloud platform to achieve repeatable, automated processes with greater scalability. We encourage you to join the SailPoint Developer Community forum at https://developer.sailpoint.com/discuss to connect with other developers using our APIs.

    The version of the OpenAPI document: v2024
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class OutlierSummary(BaseModel):
    """
    OutlierSummary
    """ # noqa: E501
    type: Optional[StrictStr] = Field(default=None, description="The type of outlier summary")
    snapshot_date: Optional[datetime] = Field(default=None, description="The date the bulk outlier detection ran/snapshot was created", alias="snapshotDate")
    total_outliers: Optional[StrictInt] = Field(default=None, description="Total number of outliers for the customer making the request", alias="totalOutliers")
    total_identities: Optional[StrictInt] = Field(default=None, description="Total number of identities for the customer making the request", alias="totalIdentities")
    total_ignored: Optional[StrictInt] = Field(default=0, alias="totalIgnored")
    __properties: ClassVar[List[str]] = ["type", "snapshotDate", "totalOutliers", "totalIdentities", "totalIgnored"]

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['LOW_SIMILARITY', 'STRUCTURAL']):
            raise ValueError("must be one of enum values ('LOW_SIMILARITY', 'STRUCTURAL')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return self.model_dump_json(by_alias=True, exclude_unset=True)


    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of OutlierSummary from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of OutlierSummary from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "type": obj.get("type"),
            "snapshotDate": obj.get("snapshotDate"),
            "totalOutliers": obj.get("totalOutliers"),
            "totalIdentities": obj.get("totalIdentities"),
            "totalIgnored": obj.get("totalIgnored") if obj.get("totalIgnored") is not None else 0
        })
        return _obj


