# coding: utf-8

"""
    Identity Security Cloud V2024 API

    Use these APIs to interact with the Identity Security Cloud platform to achieve repeatable, automated processes with greater scalability. We encourage you to join the SailPoint Developer Community forum at https://developer.sailpoint.com/discuss to connect with other developers using our APIs.

    The version of the OpenAPI document: v2024
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from sailpoint.v2024.models.password_info_account import PasswordInfoAccount
from typing import Optional, Set
from typing_extensions import Self

class PasswordInfo(BaseModel):
    """
    PasswordInfo
    """ # noqa: E501
    identity_id: Optional[StrictStr] = Field(default=None, description="Identity ID", alias="identityId")
    source_id: Optional[StrictStr] = Field(default=None, description="source ID", alias="sourceId")
    public_key_id: Optional[StrictStr] = Field(default=None, description="public key ID", alias="publicKeyId")
    public_key: Optional[StrictStr] = Field(default=None, description="User's public key with Base64 encoding", alias="publicKey")
    accounts: Optional[List[PasswordInfoAccount]] = Field(default=None, description="Account info related to queried identity and source")
    policies: Optional[List[StrictStr]] = Field(default=None, description="Password constraints")
    __properties: ClassVar[List[str]] = ["identityId", "sourceId", "publicKeyId", "publicKey", "accounts", "policies"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return self.model_dump_json(by_alias=True, exclude_unset=True)


    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PasswordInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in accounts (list)
        _items = []
        if self.accounts:
            for _item_accounts in self.accounts:
                if _item_accounts:
                    _items.append(_item_accounts.to_dict())
            _dict['accounts'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PasswordInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "identityId": obj.get("identityId"),
            "sourceId": obj.get("sourceId"),
            "publicKeyId": obj.get("publicKeyId"),
            "publicKey": obj.get("publicKey"),
            "accounts": [PasswordInfoAccount.from_dict(_item) for _item in obj["accounts"]] if obj.get("accounts") is not None else None,
            "policies": obj.get("policies")
        })
        return _obj


