# coding: utf-8

"""
    Identity Security Cloud V2024 API

    Use these APIs to interact with the Identity Security Cloud platform to achieve repeatable, automated processes with greater scalability. We encourage you to join the SailPoint Developer Community forum at https://developer.sailpoint.com/discuss to connect with other developers using our APIs.

    The version of the OpenAPI document: v2024
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class QueryType(str, Enum):
    """
    The type of query to use.  By default, the `SAILPOINT` query type is used, which requires the `query` object to be defined in the request body. To use the `queryDsl` or `typeAheadQuery` objects in the request, you must set the type to `DSL` or `TYPEAHEAD` accordingly. Additional values may be added in the future without notice.
    """

    """
    allowed enum values
    """
    DSL = 'DSL'
    SAILPOINT = 'SAILPOINT'
    TEXT = 'TEXT'
    TYPEAHEAD = 'TYPEAHEAD'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of QueryType from a JSON string"""
        return cls(json.loads(json_str))


