# coding: utf-8

"""
    Identity Security Cloud V2024 API

    Use these APIs to interact with the Identity Security Cloud platform to achieve repeatable, automated processes with greater scalability. We encourage you to join the SailPoint Developer Community forum at https://developer.sailpoint.com/discuss to connect with other developers using our APIs.

    The version of the OpenAPI document: v2024
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class RequestableObjectRequestStatus(str, Enum):
    """
    Status indicating the ability of an access request for the object to be made by or on behalf of the identity specified by *identity-id*. *AVAILABLE* indicates the object is available to request. *PENDING* indicates the object is unavailable because the identity has a pending request in flight. *ASSIGNED* indicates the object is unavailable because the identity already has the indicated role or access profile. If *identity-id* is not specified (allowed only for admin users), then status will be *AVAILABLE* for all results.
    """

    """
    allowed enum values
    """
    AVAILABLE = 'AVAILABLE'
    PENDING = 'PENDING'
    ASSIGNED = 'ASSIGNED'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of RequestableObjectRequestStatus from a JSON string"""
        return cls(json.loads(json_str))


