# coding: utf-8

"""
    Identity Security Cloud V2024 API

    Use these APIs to interact with the Identity Security Cloud platform to achieve repeatable, automated processes with greater scalability. We encourage you to join the SailPoint Developer Community forum at https://developer.sailpoint.com/discuss to connect with other developers using our APIs.

    The version of the OpenAPI document: v2024
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from sailpoint.v2024.models.base_reference_dto1 import BaseReferenceDto1
from sailpoint.v2024.models.context_attribute_dto import ContextAttributeDto
from typing import Optional, Set
from typing_extensions import Self

class RoleMatchDto(BaseModel):
    """
    RoleMatchDto
    """ # noqa: E501
    role_ref: Optional[BaseReferenceDto1] = Field(default=None, alias="roleRef")
    matched_attributes: Optional[List[ContextAttributeDto]] = Field(default=None, alias="matchedAttributes")
    __properties: ClassVar[List[str]] = ["roleRef", "matchedAttributes"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return self.model_dump_json(by_alias=True, exclude_unset=True)


    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RoleMatchDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of role_ref
        if self.role_ref:
            _dict['roleRef'] = self.role_ref.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in matched_attributes (list)
        _items = []
        if self.matched_attributes:
            for _item_matched_attributes in self.matched_attributes:
                if _item_matched_attributes:
                    _items.append(_item_matched_attributes.to_dict())
            _dict['matchedAttributes'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RoleMatchDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "roleRef": BaseReferenceDto1.from_dict(obj["roleRef"]) if obj.get("roleRef") is not None else None,
            "matchedAttributes": [ContextAttributeDto.from_dict(_item) for _item in obj["matchedAttributes"]] if obj.get("matchedAttributes") is not None else None
        })
        return _obj


