# coding: utf-8

"""
    Identity Security Cloud V2024 API

    Use these APIs to interact with the Identity Security Cloud platform to achieve repeatable, automated processes with greater scalability. We encourage you to join the SailPoint Developer Community forum at https://developer.sailpoint.com/discuss to connect with other developers using our APIs.

    The version of the OpenAPI document: v2024
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class RoleMiningPotentialRoleProvisionRequest(BaseModel):
    """
    RoleMiningPotentialRoleProvisionRequest
    """ # noqa: E501
    role_name: Optional[StrictStr] = Field(default=None, description="Name of the new role being created", alias="roleName")
    role_description: Optional[StrictStr] = Field(default=None, description="Short description of the new role being created", alias="roleDescription")
    owner_id: Optional[StrictStr] = Field(default=None, description="ID of the identity that will own this role", alias="ownerId")
    include_identities: Optional[StrictBool] = Field(default=False, description="When true, create access requests for the identities associated with the potential role", alias="includeIdentities")
    directly_assigned_entitlements: Optional[StrictBool] = Field(default=False, description="When true, assign entitlements directly to the role; otherwise, create access profiles containing the entitlements", alias="directlyAssignedEntitlements")
    __properties: ClassVar[List[str]] = ["roleName", "roleDescription", "ownerId", "includeIdentities", "directlyAssignedEntitlements"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return self.model_dump_json(by_alias=True, exclude_unset=True)


    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RoleMiningPotentialRoleProvisionRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RoleMiningPotentialRoleProvisionRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "roleName": obj.get("roleName"),
            "roleDescription": obj.get("roleDescription"),
            "ownerId": obj.get("ownerId"),
            "includeIdentities": obj.get("includeIdentities") if obj.get("includeIdentities") is not None else False,
            "directlyAssignedEntitlements": obj.get("directlyAssignedEntitlements") if obj.get("directlyAssignedEntitlements") is not None else False
        })
        return _obj


