# coding: utf-8

"""
    Identity Security Cloud V2024 API

    Use these APIs to interact with the Identity Security Cloud platform to achieve repeatable, automated processes with greater scalability. We encourage you to join the SailPoint Developer Community forum at https://developer.sailpoint.com/discuss to connect with other developers using our APIs.

    The version of the OpenAPI document: v2024
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from sailpoint.v2024.models.ref import Ref
from sailpoint.v2024.models.scope_type import ScopeType
from sailpoint.v2024.models.scope_visibility_type import ScopeVisibilityType
from sailpoint.v2024.models.visibility_criteria import VisibilityCriteria
from typing import Optional, Set
from typing_extensions import Self

class Scope(BaseModel):
    """
    This defines what access the segment is giving
    """ # noqa: E501
    scope: Optional[ScopeType] = None
    visibility: Optional[ScopeVisibilityType] = None
    scope_filter: Optional[VisibilityCriteria] = Field(default=None, alias="scopeFilter")
    scope_selection: Optional[List[Ref]] = Field(default=None, description="List of Identities that are assigned to the segment", alias="scopeSelection")
    __properties: ClassVar[List[str]] = ["scope", "visibility", "scopeFilter", "scopeSelection"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return self.model_dump_json(by_alias=True, exclude_unset=True)


    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Scope from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of scope_filter
        if self.scope_filter:
            _dict['scopeFilter'] = self.scope_filter.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in scope_selection (list)
        _items = []
        if self.scope_selection:
            for _item_scope_selection in self.scope_selection:
                if _item_scope_selection:
                    _items.append(_item_scope_selection.to_dict())
            _dict['scopeSelection'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Scope from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "scope": obj.get("scope"),
            "visibility": obj.get("visibility"),
            "scopeFilter": VisibilityCriteria.from_dict(obj["scopeFilter"]) if obj.get("scopeFilter") is not None else None,
            "scopeSelection": [Ref.from_dict(_item) for _item in obj["scopeSelection"]] if obj.get("scopeSelection") is not None else None
        })
        return _obj


