# coding: utf-8

"""
    Identity Security Cloud V2024 API

    Use these APIs to interact with the Identity Security Cloud platform to achieve repeatable, automated processes with greater scalability. We encourage you to join the SailPoint Developer Community forum at https://developer.sailpoint.com/discuss to connect with other developers using our APIs.

    The version of the OpenAPI document: v2024
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from sailpoint.v2024.models.base_reference_dto import BaseReferenceDto
from typing import Optional, Set
from typing_extensions import Self

class SourceAppAccountSource(BaseModel):
    """
    SourceAppAccountSource
    """ # noqa: E501
    id: Optional[StrictStr] = Field(default=None, description="The source ID")
    type: Optional[StrictStr] = Field(default=None, description="The source type, will always be \"SOURCE\"")
    name: Optional[StrictStr] = Field(default=None, description="The source name")
    use_for_password_management: Optional[StrictBool] = Field(default=False, description="If the source is used for password management", alias="useForPasswordManagement")
    password_policies: Optional[List[BaseReferenceDto]] = Field(default=None, description="The password policies for the source", alias="passwordPolicies")
    __properties: ClassVar[List[str]] = ["id", "type", "name", "useForPasswordManagement", "passwordPolicies"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return self.model_dump_json(by_alias=True, exclude_unset=True)


    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SourceAppAccountSource from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in password_policies (list)
        _items = []
        if self.password_policies:
            for _item_password_policies in self.password_policies:
                if _item_password_policies:
                    _items.append(_item_password_policies.to_dict())
            _dict['passwordPolicies'] = _items
        # set to None if password_policies (nullable) is None
        # and model_fields_set contains the field
        if self.password_policies is None and "password_policies" in self.model_fields_set:
            _dict['passwordPolicies'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SourceAppAccountSource from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "type": obj.get("type"),
            "name": obj.get("name"),
            "useForPasswordManagement": obj.get("useForPasswordManagement") if obj.get("useForPasswordManagement") is not None else False,
            "passwordPolicies": [BaseReferenceDto.from_dict(_item) for _item in obj["passwordPolicies"]] if obj.get("passwordPolicies") is not None else None
        })
        return _obj


