# coding: utf-8

"""
    Identity Security Cloud V2024 API

    Use these APIs to interact with the Identity Security Cloud platform to achieve repeatable, automated processes with greater scalability. We encourage you to join the SailPoint Developer Community forum at https://developer.sailpoint.com/discuss to connect with other developers using our APIs.

    The version of the OpenAPI document: v2024
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class TaskDefinitionSummary(BaseModel):
    """
    Definition of a type of task, used to invoke tasks
    """ # noqa: E501
    id: StrictStr = Field(description="System-generated unique ID of the TaskDefinition")
    unique_name: StrictStr = Field(description="Name of the TaskDefinition", alias="uniqueName")
    description: StrictStr = Field(description="Description of the TaskDefinition")
    parent_name: StrictStr = Field(description="Name of the parent of the TaskDefinition", alias="parentName")
    executor: Optional[StrictStr] = Field(description="Executor of the TaskDefinition")
    arguments: Dict[str, Any] = Field(description="Formal parameters of the TaskDefinition, without values")
    __properties: ClassVar[List[str]] = ["id", "uniqueName", "description", "parentName", "executor", "arguments"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return self.model_dump_json(by_alias=True, exclude_unset=True)


    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TaskDefinitionSummary from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if executor (nullable) is None
        # and model_fields_set contains the field
        if self.executor is None and "executor" in self.model_fields_set:
            _dict['executor'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TaskDefinitionSummary from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "uniqueName": obj.get("uniqueName"),
            "description": obj.get("description"),
            "parentName": obj.get("parentName"),
            "executor": obj.get("executor"),
            "arguments": obj.get("arguments")
        })
        return _obj


