# coding: utf-8

"""
    Identity Security Cloud V2024 API

    Use these APIs to interact with the Identity Security Cloud platform to achieve repeatable, automated processes with greater scalability. We encourage you to join the SailPoint Developer Community forum at https://developer.sailpoint.com/discuss to connect with other developers using our APIs.

    The version of the OpenAPI document: v2024
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class V3ConnectorDto(BaseModel):
    """
    V3ConnectorDto
    """ # noqa: E501
    name: Optional[StrictStr] = Field(default=None, description="The connector name")
    type: Optional[StrictStr] = Field(default=None, description="The connector type")
    script_name: Optional[StrictStr] = Field(default=None, description="The connector script name", alias="scriptName")
    class_name: Optional[StrictStr] = Field(default=None, description="The connector class name.", alias="className")
    features: Optional[List[StrictStr]] = Field(default=None, description="The list of features supported by the connector")
    direct_connect: Optional[StrictBool] = Field(default=False, description="true if the source is a direct connect source", alias="directConnect")
    connector_metadata: Optional[Dict[str, Any]] = Field(default=None, description="A map containing metadata pertinent to the connector", alias="connectorMetadata")
    status: Optional[StrictStr] = Field(default=None, description="The connector status")
    __properties: ClassVar[List[str]] = ["name", "type", "scriptName", "className", "features", "directConnect", "connectorMetadata", "status"]

    @field_validator('status')
    def status_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['DEPRECATED', 'DEVELOPMENT', 'DEMO', 'RELEASED']):
            raise ValueError("must be one of enum values ('DEPRECATED', 'DEVELOPMENT', 'DEMO', 'RELEASED')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return self.model_dump_json(by_alias=True, exclude_unset=True)


    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of V3ConnectorDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if class_name (nullable) is None
        # and model_fields_set contains the field
        if self.class_name is None and "class_name" in self.model_fields_set:
            _dict['className'] = None

        # set to None if features (nullable) is None
        # and model_fields_set contains the field
        if self.features is None and "features" in self.model_fields_set:
            _dict['features'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of V3ConnectorDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "type": obj.get("type"),
            "scriptName": obj.get("scriptName"),
            "className": obj.get("className"),
            "features": obj.get("features"),
            "directConnect": obj.get("directConnect") if obj.get("directConnect") is not None else False,
            "connectorMetadata": obj.get("connectorMetadata"),
            "status": obj.get("status")
        })
        return _obj


