# coding: utf-8

"""
    Identity Security Cloud V3 API

    Use these APIs to interact with the Identity Security Cloud platform to achieve repeatable, automated processes with greater scalability. We encourage you to join the SailPoint Developer Community forum at https://developer.sailpoint.com/discuss to connect with other developers using our APIs.

    The version of the OpenAPI document: 3.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from sailpoint.v3.models.tagged_object_dto import TaggedObjectDto
from typing import Optional, Set
from typing_extensions import Self

class BulkAddTaggedObject(BaseModel):
    """
    BulkAddTaggedObject
    """ # noqa: E501
    object_refs: Optional[List[TaggedObjectDto]] = Field(default=None, alias="objectRefs")
    tags: Optional[List[StrictStr]] = Field(default=None, description="Label to be applied to an Object")
    operation: Optional[StrictStr] = Field(default='APPEND', description="If APPEND, tags are appended to the list of tags for the object. A 400 error is returned if this would add duplicate tags to the object.  If MERGE, tags are merged with the existing tags. Duplicate tags are silently ignored.")
    __properties: ClassVar[List[str]] = ["objectRefs", "tags", "operation"]

    @field_validator('operation')
    def operation_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['APPEND', 'MERGE']):
            raise ValueError("must be one of enum values ('APPEND', 'MERGE')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return self.model_dump_json(by_alias=True, exclude_unset=True)


    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of BulkAddTaggedObject from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in object_refs (list)
        _items = []
        if self.object_refs:
            for _item_object_refs in self.object_refs:
                if _item_object_refs:
                    _items.append(_item_object_refs.to_dict())
            _dict['objectRefs'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of BulkAddTaggedObject from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "objectRefs": [TaggedObjectDto.from_dict(_item) for _item in obj["objectRefs"]] if obj.get("objectRefs") is not None else None,
            "tags": obj.get("tags"),
            "operation": obj.get("operation") if obj.get("operation") is not None else 'APPEND'
        })
        return _obj


