# coding: utf-8

"""
    Identity Security Cloud V3 API

    Use these APIs to interact with the Identity Security Cloud platform to achieve repeatable, automated processes with greater scalability. We encourage you to join the SailPoint Developer Community forum at https://developer.sailpoint.com/discuss to connect with other developers using our APIs.

    The version of the OpenAPI document: 3.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import unittest

from sailpoint.v3.models.search import Search

class TestSearch(unittest.TestCase):
    """Search unit test stubs"""

    def setUp(self):
        pass

    def tearDown(self):
        pass

    def make_instance(self, include_optional) -> Search:
        """Test Search
            include_optional is a boolean, when False only required
            params are included, when True both required and
            optional params are included """
        # uncomment below to create an instance of `Search`
        """
        model = Search()
        if include_optional:
            return Search(
                indices = [identities],
                query_type = 'SAILPOINT',
                query_version = None,
                query = sailpoint.v3.models.query.Query(
                    query = 'name:a*', 
                    fields = '[firstName,lastName,email]', 
                    time_zone = 'America/Chicago', 
                    inner_hit = sailpoint.v3.models.inner_hit.InnerHit(
                        query = 'source.name:\"Active Directory\"', 
                        type = 'access', ), ),
                query_dsl = {match={name=john.doe}},
                text_query = sailpoint.v3.models.text_query.TextQuery(
                    terms = [The quick brown fox, 3141592, 7], 
                    fields = [displayName, employeeNumber, roleCount], 
                    match_any = False, 
                    contains = True, ),
                type_ahead_query = sailpoint.v3.models.type_ahead_query.TypeAheadQuery(
                    query = 'Work', 
                    field = 'source.name', 
                    nested_type = 'access', 
                    max_expansions = 10, 
                    size = 100, 
                    sort = 'desc', 
                    sort_by_value = True, ),
                include_nested = True,
                query_result_filter = sailpoint.v3.models.query_result_filter.QueryResultFilter(
                    includes = [name, displayName], 
                    excludes = [stacktrace], ),
                aggregation_type = 'DSL',
                aggregations_version = None,
                aggregations_dsl = {},
                aggregations = None,
                sort = [displayName, +id],
                search_after = [John Doe, 2c91808375d8e80a0175e1f88a575221],
                filters = {}
            )
        else:
            return Search(
        )
        """

    def testSearch(self):
        """Test Search"""
        # inst_req_only = self.make_instance(include_optional=False)
        # inst_req_and_optional = self.make_instance(include_optional=True)

if __name__ == '__main__':
    unittest.main()
